unofficial mirror of notmuch@notmuchmail.org
 help / color / mirror / code / Atom feed
From: Dmitry Kurochkin <dmitry.kurochkin@gmail.com>
To: notmuch@notmuchmail.org
Subject: [PATCH v3 1/3] test: add functions to count how much times notmuch was called
Date: Tue, 29 Nov 2011 01:13:57 +0400	[thread overview]
Message-ID: <1322514839-28441-2-git-send-email-dmitry.kurochkin@gmail.com> (raw)
In-Reply-To: <1322514839-28441-1-git-send-email-dmitry.kurochkin@gmail.com>

The patch adds two auxiliary functions and a variable:

  notmuch_counter_reset
  $notmuch_counter_command
  notmuch_counter_value

They allow to count how many times notmuch binary is called.
notmuch_counter_reset() function generates a script that counts how
many times it is called and resets the counter to zero.  The function
sets $notmuch_counter_command variable to the path to the generated
script that should be called instead of notmuch to do the counting.
The notmuch_counter_value() function returns the current counter
value.
---
 test/README      |   16 ++++++++++++++--
 test/test-lib.sh |   32 ++++++++++++++++++++++++++++++++
 2 files changed, 46 insertions(+), 2 deletions(-)

diff --git a/test/README b/test/README
index 2481f16..5dc0638 100644
--- a/test/README
+++ b/test/README
@@ -187,8 +187,8 @@ library for your script to use.
    is to summarize successes and failures in the test script and
    exit with an appropriate error code.
 
-There are also a number of mail-specific functions which are useful in
-writing tests:
+There are also a number of notmuch-specific auxiliary functions and
+variables which are useful in writing tests:
 
   generate_message
 
@@ -212,3 +212,15 @@ writing tests:
     will initialize the mail database to a known state of 50 sample
     messages, (culled from the early history of the notmuch mailing
     list).
+
+  notmuch_counter_reset
+  $notmuch_counter_command
+  notmuch_counter_value
+
+    These allow to count how many times notmuch binary is called.
+    notmuch_counter_reset() function generates a script that counts
+    how many times it is called and resets the counter to zero.  The
+    function sets $notmuch_counter_command variable to the path to the
+    generated script that should be called instead of notmuch to do
+    the counting.  The notmuch_counter_value() function prints the
+    current counter value.
diff --git a/test/test-lib.sh b/test/test-lib.sh
index 11e6646..7798e21 100644
--- a/test/test-lib.sh
+++ b/test/test-lib.sh
@@ -919,6 +919,38 @@ test_emacs () {
 	emacsclient --socket-name="$EMACS_SERVER" --eval "(progn $@)"
 }
 
+# Creates a script that counts how much time it is executed and calls
+# notmuch.  $notmuch_counter_command is set to the path to the
+# generated script.  Use notmuch_counter_value() function to get the
+# current counter value.
+notmuch_counter_reset () {
+	notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
+	if [ ! -x "$notmuch_counter_command" ]; then
+		notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
+		cat >"$notmuch_counter_command" <<EOF || return
+#!/bin/sh
+
+read count < "$notmuch_counter_state_path"
+echo \$(expr \$count + 1) > "$notmuch_counter_state_path"
+
+exec notmuch "\$@"
+EOF
+		chmod +x "$notmuch_counter_command" || return
+	fi
+
+	echo 0 > "$notmuch_counter_state_path"
+}
+
+# Returns the current notmuch counter value.
+notmuch_counter_value () {
+	if [ -r "$notmuch_counter_state_path" ]; then
+		read count < "$notmuch_counter_state_path"
+	else
+		count=0
+	fi
+	echo $count
+}
+
 test_reset_state_ () {
 	test -z "$test_init_done_" && test_init_
 
-- 
1.7.7.3

  reply	other threads:[~2011-11-28 21:14 UTC|newest]

Thread overview: 30+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2011-11-26  1:44 [PATCH 1/3] test: add functions to count how much times notmuch was called Dmitry Kurochkin
2011-11-26  1:44 ` [PATCH 2/3] test: check that Emacs UI does not call notmuch for non-inlinable parts Dmitry Kurochkin
2011-11-28  2:46   ` Austin Clements
2011-11-26  1:44 ` [PATCH 3/3] emacs: do not call notmuch show " Dmitry Kurochkin
2011-11-28  2:54   ` Austin Clements
2011-11-28  2:44 ` [PATCH 1/3] test: add functions to count how much times notmuch was called Austin Clements
2011-11-28  3:09   ` Dmitry Kurochkin
2011-11-28  3:28 ` [PATCH 0/3] emacs: do not call notmuch show for non-inlinable parts Dmitry Kurochkin
2011-11-28  3:28   ` [PATCH 1/3] test: add functions to count how much times notmuch was called Dmitry Kurochkin
2011-11-28 20:42     ` Tomi Ollila
2011-11-28 21:26       ` Dmitry Kurochkin
2011-11-29 12:58         ` Tomi Ollila
2011-11-29 21:03           ` Dmitry Kurochkin
2011-11-30 11:53             ` Tomi Ollila
2011-11-29 14:40         ` Jameson Graef Rollins
2011-11-28  3:28   ` [PATCH 2/3] test: check that Emacs UI does not call notmuch for non-inlinable parts Dmitry Kurochkin
2011-11-28  3:28   ` [PATCH 3/3] emacs: do not call notmuch show " Dmitry Kurochkin
2011-11-28  3:39   ` [PATCH 0/3] " Austin Clements
2011-11-28 14:24     ` Jameson Graef Rollins
2011-11-28 21:13 ` [PATCH v3 " Dmitry Kurochkin
2011-11-28 21:13   ` Dmitry Kurochkin [this message]
2011-11-28 21:13   ` [PATCH v3 2/3] test: check that Emacs UI does not call notmuch " Dmitry Kurochkin
2011-11-28 21:13   ` [PATCH v3 3/3] emacs: do not call notmuch show " Dmitry Kurochkin
2011-11-29 21:19 ` [PATCH v4 0/3] " Dmitry Kurochkin
2011-11-29 21:19   ` [PATCH v4 1/3] test: add functions to count how much times notmuch was called Dmitry Kurochkin
2011-11-30 11:57     ` Tomi Ollila
2011-11-29 21:19   ` [PATCH v4 2/3] test: check that Emacs UI does not call notmuch for non-inlinable parts Dmitry Kurochkin
2011-11-29 21:19   ` [PATCH v4 3/3] emacs: do not call notmuch show " Dmitry Kurochkin
2011-12-07 15:11   ` [PATCH v4 0/3] " Dmitry Kurochkin
2011-12-08  1:00   ` David Bremner

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: https://notmuchmail.org/

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1322514839-28441-2-git-send-email-dmitry.kurochkin@gmail.com \
    --to=dmitry.kurochkin@gmail.com \
    --cc=notmuch@notmuchmail.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://yhetil.org/notmuch.git/

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).